﻿Imports Telerik.WinControls.Primitives
Imports Telerik.WinControls.UI
Imports Telerik.WinControls

Public Class Form1
    Sub New()
        InitializeComponent()
        Me.RadButton1.BackgroundImage = My.Resources.demo
        Me.RadButton1.BackgroundImageLayout = ImageLayout.Stretch
        Me.RadButton1.DisplayStyle = DisplayStyle.Image
        Me.RadButton1.EnableGesture(GestureType.All)
        Me.RadButton1.ButtonElement.ButtonFillElement.Visibility = ElementVisibility.Collapsed
        Me.RadButton1.Visible = False

        Dim custom As New CustomPanel()
        custom.Location = New Point(50, 50)
        custom.Size = New Size(200, 200)
        custom.Dock = DockStyle.Fill
        Me.Controls.Add(custom)
    End Sub
    Private Sub RadButton1_Click(sender As Object, e As EventArgs) Handles RadButton1.Click
        MessageBox.Show("Test")
    End Sub
    Public Class CustomPanel
        Inherits RadControl
        Public Class CustomPanelLayout
            Inherits Telerik.WinControls.Layouts.LayoutPanel
        End Class
        Public Sub New()
            Me.EnableGesture(GestureType.All)
        End Sub
        Private m_layout As CustomPanelLayout
        Private button As LightVisualElement

        Protected Overrides Sub CreateChildItems(ByVal parent As RadElement)
            MyBase.CreateChildItems(parent)
            m_layout = New CustomPanelLayout()
            parent.Children.Add(m_layout)
            button = New LightVisualElement()
            button.Image = My.Resources.demo
            button.ImageLayout = ImageLayout.Stretch
            AddHandler button.Click, AddressOf button_Click
            button.AutoSize = False
            button.Size = New Size(100, 100)
            button.Location = New Point(100, 100)
            Me.m_layout.Children.Add(button)
            AddHandler button.PanGesture, AddressOf button_PanGesture
            AddHandler button.ZoomGesture, AddressOf button_ZoomGesture
            AddHandler button.RotateGesture, AddressOf button_RotateGesture
        End Sub
        Private Sub button_RotateGesture(ByVal sender As Object, ByVal e As RotateGestureEventArgs)
            button.AngleTransform -= CSng(e.Angle * 180.0R / Math.PI)
        End Sub
        Private Sub button_ZoomGesture(ByVal sender As Object, ByVal e As ZoomGestureEventArgs)
            button.ScaleTransform = New SizeF(CSng(button.ScaleTransform.Width * e.ZoomFactor), CSng(button.ScaleTransform.Height * e.ZoomFactor))
        End Sub
        Private Sub button_PanGesture(ByVal sender As Object, ByVal e As PanGestureEventArgs)
            button.Location = New Point(button.Location.X + e.Offset.Width, button.Location.Y + e.Offset.Height)
        End Sub
        Private Sub button_Click(sender As Object, e As EventArgs)
            MessageBox.Show("Test")
        End Sub
    End Class
End Class
